# cache2k 1.9.1.Alpha "North Atlantic"

This is a preview release for evaluation purposes and should not be used in production.
The preview is in preparation for version 2 which will have some major breaking
changes to the previous releases. The final release will be **2.0.0.Final - "North Atlantic"**.

## New and Noteworthy

- cache2k-api, cache2k-core, cache2k-jmx and cache2k-config are fully modularized
- Requires at least Java 8 to run
- Adaptions to Java 8 on API level. E.g. use of Duration in the configuration
- New interfaces for `CacheLoader` and `CacheWriter`
- Removal of deprecated classes and methods
- JMX and XML configuration support is no longer part of `cache2k-core`
- OSGi support with `cache2k-osgi-all` removed, see: https://github.com/cache2k/cache2k/issues/83

## Possible Breakages

Since this is a major release, some rarely used things in the API are 
changed without backwards compatibility. Most code is supposed to run
without breaking.

- Requires at least Java 8 to run
- Remove deprecated classes and methods: `Cache.prefetch`, `Cache.prefetchAll`, `IntCache`, `LongCache`, 
`CacheEntry.getLastModification`, `AbstractCacheEntry`
- Incompatible change of `CustomizationSupplier` interface
- `org.cache2k.integration.ResiliencePolicy` removed. Replaced by: `org.cache2k.io.ResiliencePolicy`
- JMX support moved from `cache2k-core` to `cache2k-jmx` to minimize module dependencies
- XML configuration moved from `cache2k-core` to `cache2k-config` to minimize module dependencies
- Dropped apache commons logging support. Commons logging seems to be not 
  maintained any more and lacks Jigsaw/module support.
- Drop support for XML configuration on Android, removed XML pull dependency
  (The Android will be potentially unsupported in cache2k V2 at first)
- Moved JCache configuration classes in `org.cache.jcache` from `cache2k-api` to `cache2k-jcache`.
  If these are used, `cache2k-jcache` needs to be in compile scope.  
- `Cache2kConfiguration`: Changed all parameters of type long, representing
  milliseconds to type `Duration` 

## API Changes 

- `org.cache2k.integration.CacheLoader` and everything in package `org.cache2k.integration` 
  is deprecated. Replacements are available in `org.cache2k.io`. This major change was done to
  change from abstract classes to interface. The new package was introduced for smoother transition
  to keep the previous classes and deprecated them.
- Add `Cache.loadAll` and `Cache.reloadAll` which return `CompletableFuture`
  Old methods which use `CacheOperationCompletionListener` are deprecated   
- Remove deprecated classes and methods: `Cache.prefetch`, `Cache.prefetchAll`, `IntCache`, `LongCache`, 
`CacheEntry.getLastModification`, `AbstractCacheEntry`

## Fixes and Improvements

- All cache customizations (e.g. `CacheLoader`) implement `Customization`.
- Speedup of internal hash table, because compatibility for Java 6 could be removed